diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-primary-channels-test.cc ns-3.46/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.45/src/wifi/test/wifi-primary-channels-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-primary-channels-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -197,14 +197,15 @@
     uint8_t m_nStationsPerBss;                    ///< number of stations per AP
     std::vector<NetDeviceContainer> m_staDevices; ///< containers for stations' NetDevices
     NetDeviceContainer m_apDevices;               ///< container for AP's NetDevice
-    std::vector<std::bitset<74>> m_received;  /**< whether the last packet transmitted to/from each
-                                                 of  the (up to 74 per BSS) stations was received */
-    std::vector<std::bitset<74>> m_processed; /**< whether the last packet transmitted to/from each
-                                                 of the (up to 74 per BSS) stations was processed */
-    Time m_time;                              ///< the time when the current action is executed
-    Ptr<WifiPsdu> m_trigger;                  ///< Basic Trigger Frame
-    WifiTxVector m_triggerTxVector;           ///< TX vector for Basic Trigger Frame
-    Time m_triggerTxDuration;                 ///< TX duration for Basic Trigger Frame
+    std::vector<std::bitset<144>> m_received; /**< whether the last packet transmitted to/from each
+                                                of  the (up to 144 per BSS) stations was received */
+    std::vector<std::bitset<144>>
+        m_processed;                /**< whether the last packet transmitted to/from each
+                                      of the (up to 144 per BSS) stations was processed */
+    Time m_time;                    ///< the time when the current action is executed
+    Ptr<WifiPsdu> m_trigger;        ///< Basic Trigger Frame
+    WifiTxVector m_triggerTxVector; ///< TX vector for Basic Trigger Frame
+    Time m_triggerTxDuration;       ///< TX duration for Basic Trigger Frame
 };
 
 WifiPrimaryChannelsTest::WifiPrimaryChannelsTest(WifiStandard standard,
@@ -381,10 +382,7 @@
                 "WaitBeaconTimeout",
                 TimeValue(MicroSeconds(102400))); // same as BeaconInterval
 
-    AttributeContainerValue<
-        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-        ';'>
-        channelValue;
+    WifiPhy::ChannelSettingsValue channelValue;
 
     // Each BSS uses a distinct primary20 channel
     for (uint8_t bss = 0; bss < m_nBss; bss++)
@@ -651,6 +649,7 @@
      */
     nRounds = 2;
     nApsPerRound = Count20MHzSubchannels(m_channelWidth) / 2;
+    const auto mc = GetModulationClassForStandard(m_standard);
     for (MHz_u txChannelWidth{20}; txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
@@ -659,12 +658,10 @@
 
         for (uint16_t round = 0; round < nRounds; round++)
         {
-            for (uint32_t type = 0; type < static_cast<uint32_t>(WifiRu::GetMaxRuType(
-                                               GetModulationClassForStandard(m_standard)));
-                 ++type)
+            for (uint32_t type = 0; type < static_cast<uint32_t>(WifiRu::GetMaxRuType(mc)); ++type)
             {
                 auto ruType = static_cast<RuType>(type);
-                std::size_t nRus = HeRu::GetNRus(txChannelWidth, ruType);
+                std::size_t nRus = WifiRu::GetNRus(txChannelWidth, ruType, mc);
                 std::set<uint8_t> txBss;
                 if (nRus > 0)
                 {
@@ -710,12 +707,10 @@
 
         for (uint16_t round = 0; round < nRounds; round++)
         {
-            for (uint32_t type = 0; type < static_cast<uint32_t>(WifiRu::GetMaxRuType(
-                                               GetModulationClassForStandard(m_standard)));
-                 ++type)
+            for (uint32_t type = 0; type < static_cast<uint32_t>(WifiRu::GetMaxRuType(mc)); ++type)
             {
                 auto ruType = static_cast<RuType>(type);
-                std::size_t nRus = HeRu::GetNRus(txChannelWidth, ruType);
+                std::size_t nRus = WifiRu::GetNRus(txChannelWidth, ruType, mc);
                 std::set<uint8_t> txBss;
                 if (nRus > 0)
                 {
@@ -834,7 +829,14 @@
 
     WifiConstPsduMap psduMap;
 
-    for (std::size_t i = 1; i <= nRus; i++)
+    auto numRus{nRus};
+    if ((m_standard != WIFI_STANDARD_80211ax) && (ruType == RuType::RU_26_TONE))
+    {
+        // for the loop, take undefined RUs for EHT into account
+        numRus += (txChannelWidth / MHz_u{80});
+    }
+    std::size_t staIdx{0};
+    for (std::size_t i = 1; i <= numRus; ++i)
     {
         auto primary80OrLow80{true};
         auto primary160{true};
@@ -861,13 +863,24 @@
                 primary80OrLow80 = p80OrLow80;
             }
         }
+        if ((m_standard != WIFI_STANDARD_80211ax) && (txChannelWidth >= MHz_u{80}) &&
+            (ruType == RuType::RU_26_TONE) && (index == 19))
+        {
+            // skip undefined RU for EHT
+            continue;
+        }
         const auto ru =
             (m_standard == WIFI_STANDARD_80211ax)
                 ? WifiRu::RuSpec(HeRu::RuSpec{ruType, index, primary80OrLow80})
                 : WifiRu::RuSpec(EhtRu::RuSpec{ruType, index, primary160, primary80OrLow80});
 
-        auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(i - 1));
-        uint16_t staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
+        NS_ABORT_IF((bss >= m_staDevices.size()) || (staIdx >= m_staDevices[bss].GetN()));
+        auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(staIdx));
+        ++staIdx;
+
+        NS_ABORT_IF(!staDev);
+        const auto staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
+
         txVector.SetHeMuUserInfo(staId, {ru, 8, 1});
         hdr.SetAddr1(staDev->GetMac()->GetAddress());
         psduMap[staId] = Create<const WifiPsdu>(Create<Packet>(1000), hdr);
@@ -933,7 +946,14 @@
         false,
         bssColor);
 
-    for (std::size_t i = 1; i <= nRus; i++)
+    auto numRus{nRus};
+    if ((m_standard != WIFI_STANDARD_80211ax) && (ruType == RuType::RU_26_TONE))
+    {
+        // for the loop, take undefined RUs for EHT into account
+        numRus += (txChannelWidth / MHz_u{80});
+    }
+    std::size_t staIdx{0};
+    for (std::size_t i = 1; i <= numRus; ++i)
     {
         NS_LOG_INFO("*** BSS " << +bss << " STA " << i - 1 << " transmits on primary "
                                << txChannelWidth
@@ -964,14 +984,22 @@
                 primary80OrLow80 = p80OrLow80;
             }
         }
+        if ((m_standard != WIFI_STANDARD_80211ax) && (txChannelWidth >= MHz_u{80}) &&
+            (ruType == RuType::RU_26_TONE) && (index == 19))
+        {
+            // skip undefined RU for EHT
+            continue;
+        }
         const auto ru =
             (m_standard == WIFI_STANDARD_80211ax)
                 ? WifiRu::RuSpec(HeRu::RuSpec{ruType, index, primary80OrLow80})
                 : WifiRu::RuSpec(EhtRu::RuSpec{ruType, index, primary160, primary80OrLow80});
 
-        auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(i - 1));
-        uint16_t staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
+        NS_ABORT_IF((bss >= m_staDevices.size()) || (staIdx >= m_staDevices[bss].GetN()));
+        auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(staIdx));
+        ++staIdx;
 
+        const auto staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
         WifiTxVector txVector(
             (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs8() : EhtPhy::GetEhtMcs8(),
             0,
@@ -1010,7 +1038,7 @@
 
     // AP's PHY expects to receive a TRIGVECTOR (just once)
     trigVector.SetLength(length);
-    auto apHePhy = StaticCast<HePhy>(apDev->GetPhy()->GetLatestPhyEntity());
+    auto apHePhy = std::static_pointer_cast<HePhy>(apDev->GetPhy()->GetLatestPhyEntity());
     apHePhy->SetTrigVector(trigVector, duration);
 }
 
@@ -1594,10 +1622,12 @@
         AddTestCase(new WifiPrimaryChannelsTest(standard, MHz_u{160}, false),
                     TestCase::Duration::TAKES_FOREVER);
     }
-    AddTestCase(new WifiPrimaryChannelsTest(WIFI_STANDARD_80211be, MHz_u{320}, true),
+    // TODO: activate WifiPrimaryChannelsTest for 320 MHz channels once PHY operations are optimized
+    // to run faster, otherwise run-time is too long
+    /*AddTestCase(new WifiPrimaryChannelsTest(WIFI_STANDARD_80211be, MHz_u{320}, true),
                 TestCase::Duration::TAKES_FOREVER);
     AddTestCase(new WifiPrimaryChannelsTest(WIFI_STANDARD_80211be, MHz_u{320}, false),
-                TestCase::Duration::TAKES_FOREVER);
+                TestCase::Duration::TAKES_FOREVER);*/
     AddTestCase(new Wifi20MHzChannelIndicesTest(), TestCase::Duration::QUICK);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-retransmit-test.cc ns-3.46/src/wifi/test/wifi-retransmit-test.cc
--- ns-3.45/src/wifi/test/wifi-retransmit-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/test/wifi-retransmit-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -309,7 +309,7 @@
 {
     const auto psduNumber = std::distance(m_events.cbegin(), m_eventIt);
     const auto apAddr = Mac48Address::ConvertFrom(m_apDevice.Get(0)->GetAddress());
-    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, apAddr, 0};
+    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, apAddr, 0};
     const auto staQueue = m_staMac->GetTxopQueue(AC_BE);
     NS_TEST_EXPECT_MSG_EQ(seqNoRetryCountMap.size(),
                           staQueue->GetNPackets(queueId),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/test/wifi-static-emlsr-test.cc ns-3.46/src/wifi/test/wifi-static-emlsr-test.cc
--- ns-3.45/src/wifi/test/wifi-static-emlsr-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/wifi/test/wifi-static-emlsr-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,374 @@
+/*
+ * Copyright (c) 2025
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/assert.h"
+#include "ns3/attribute-container.h"
+#include "ns3/boolean.h"
+#include "ns3/emlsr-manager.h"
+#include "ns3/frame-exchange-manager.h"
+#include "ns3/log.h"
+#include "ns3/mac48-address.h"
+#include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/node-container.h"
+#include "ns3/rng-seed-manager.h"
+#include "ns3/simulator.h"
+#include "ns3/spectrum-wifi-helper.h"
+#include "ns3/sta-wifi-mac.h"
+#include "ns3/string.h"
+#include "ns3/test.h"
+#include "ns3/wifi-mac-header.h"
+#include "ns3/wifi-mac-helper.h"
+#include "ns3/wifi-mac.h"
+#include "ns3/wifi-net-device.h"
+#include "ns3/wifi-static-setup-helper.h"
+#include "ns3/wifi-utils.h"
+
+#include <algorithm>
+#include <iterator>
+#include <set>
+#include <unordered_map>
+
+/// @ingroup wifi-test
+/// @ingroup tests
+/// @brief WifiStaticSetupHelper EMLSR setup test suite
+/// Test suite intended to test static EMLSR setup between AP MLD and client MLD.
+/// The test prepares AP WifiNetDevice and client WifiNetDevice based on test vector input and
+/// performs static EMLSR setup using WifiStaticSetupHelper. The test verifies if EMLSR state
+/// machine at ApWifiMac and StaWifiMac has been updated correctly.
+
+using namespace ns3;
+NS_LOG_COMPONENT_DEFINE("WifiStaticEmlsrTestSuite");
+
+namespace WifiStaticEmlsrTestConstants
+{
+const auto DEFAULT_RNG_SEED = 3;
+const auto DEFAULT_RNG_RUN = 7;
+const auto DEFAULT_STREAM_INDEX = 100;
+const auto DEFAULT_SIM_STOP_TIME = NanoSeconds(1);
+const auto DEFAULT_BEACON_GEN = false;
+const auto DEFAULT_DATA_MODE = "HeMcs3";
+const auto DEFAULT_CONTROL_MODE = "OfdmRate24Mbps";
+const auto DEFAULT_SWITCH_DELAY = MicroSeconds(64);
+const auto DEFAULT_AUX_PHY_CH_WIDTH = MHz_u{20};
+const auto DEFAULT_SWITCH_AUX_PHY = false;
+const auto DEFAULT_WIFI_STANDARD = WifiStandard::WIFI_STANDARD_80211be;
+const auto DEFAULT_SSID = Ssid("static-assoc-test");
+const std::string CHANNEL_0 = "{42, 80, BAND_5GHZ, 0}";
+const std::string CHANNEL_1 = "{23, 80, BAND_6GHZ, 0}";
+const std::string CHANNEL_2 = "{2, 0, BAND_2_4GHZ, 0}";
+const std::vector<std::string> DEFAULT_AP_CHS = {CHANNEL_0, CHANNEL_1, CHANNEL_2};
+using ChannelMap = std::unordered_map<WifiPhyBand, Ptr<MultiModelSpectrumChannel>>;
+} // namespace WifiStaticEmlsrTestConstants
+
+/// @brief test case information
+struct WifiStaticEmlsrTestVector
+{
+    std::string name;                     ///< Test case name
+    std::vector<std::string> clientChs{}; ///< Channel settings for client device
+    std::set<uint8_t> emlsrLinks{};       ///< EMLSR mode links
+    Time switchDelay{WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY}; ///< Radio Switch Delay
+    MHz_u auxPhyWidth{
+        WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH}; ///< Aux PHY channel width
+    bool switchAuxPhy{WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY}; ///< Switch Aux PHY
+};
+
+/**
+ * Test static setup of the EMLSR mode.
+ *
+ * It is checked that:
+ * - EMLSR mode is enabled on the expected set of links, both at client side and AP MLD side
+ * - the channel switch delay is configured on the client links as expected
+ */
+class WifiStaticEmlsrTest : public TestCase
+{
+  public:
+    /**
+     * Constructor.
+     *
+     * @param testVec the test vector
+     */
+    WifiStaticEmlsrTest(const WifiStaticEmlsrTestVector& testVec);
+
+  private:
+    /// Construct WifiNetDevice
+    /// @param isAp true if AP, false otherwise
+    /// @param channelMap created spectrum channels
+    /// @return constructed WifiNetDevice
+    Ptr<WifiNetDevice> GetWifiNetDevice(bool isAp,
+                                        const WifiStaticEmlsrTestConstants::ChannelMap& channelMap);
+
+    /// Construct PHY helper based on input operating channels
+    /// @param settings vector of strings specifying the operating channels to configure
+    /// @param channelMap created spectrum channels
+    /// @return PHY helper
+    SpectrumWifiPhyHelper GetPhyHelper(
+        const std::vector<std::string>& settings,
+        const WifiStaticEmlsrTestConstants::ChannelMap& channelMap) const;
+
+    /// @return the WifiHelper
+    WifiHelper GetWifiHelper() const;
+    /// @return the AP MAC helper
+    WifiMacHelper GetApMacHelper() const;
+    /// @return the Client MAC helper
+    WifiMacHelper GetClientMacHelper() const;
+    void ValidateEmlsr(); ///< Validate EMLSR setup
+    void DoRun() override;
+    void DoSetup() override;
+
+    WifiStaticEmlsrTestVector m_testVec;     ///< Test vector
+    Ptr<WifiNetDevice> m_apDev{nullptr};     ///< AP WiFi device
+    Ptr<WifiNetDevice> m_clientDev{nullptr}; ///< client WiFi device
+};
+
+WifiStaticEmlsrTest::WifiStaticEmlsrTest(const WifiStaticEmlsrTestVector& testVec)
+    : TestCase(testVec.name),
+      m_testVec(testVec)
+{
+}
+
+WifiHelper
+WifiStaticEmlsrTest::GetWifiHelper() const
+{
+    WifiHelper wifiHelper;
+    wifiHelper.SetStandard(WifiStaticEmlsrTestConstants::DEFAULT_WIFI_STANDARD);
+    wifiHelper.SetRemoteStationManager(
+        "ns3::ConstantRateWifiManager",
+        "DataMode",
+        StringValue(WifiStaticEmlsrTestConstants::DEFAULT_DATA_MODE),
+        "ControlMode",
+        StringValue(WifiStaticEmlsrTestConstants::DEFAULT_CONTROL_MODE));
+    wifiHelper.ConfigEhtOptions("EmlsrActivated", BooleanValue(true));
+    return wifiHelper;
+}
+
+SpectrumWifiPhyHelper
+WifiStaticEmlsrTest::GetPhyHelper(const std::vector<std::string>& settings,
+                                  const WifiStaticEmlsrTestConstants::ChannelMap& channelMap) const
+{
+    NS_ASSERT(not settings.empty());
+    SpectrumWifiPhyHelper helper(settings.size());
+
+    uint8_t linkId = 0;
+    for (const auto& str : settings)
+    {
+        helper.Set(linkId, "ChannelSettings", StringValue(str));
+        helper.Set(linkId, "ChannelSwitchDelay", TimeValue(m_testVec.switchDelay));
+        auto channelConfig = WifiChannelConfig::FromString(str);
+        auto phyBand = channelConfig.front().band;
+        auto freqRange = GetFrequencyRange(phyBand);
+        helper.AddPhyToFreqRangeMapping(linkId, freqRange);
+        helper.AddChannel(channelMap.at(phyBand), freqRange);
+
+        ++linkId;
+    }
+    return helper;
+}
+
+WifiMacHelper
+WifiStaticEmlsrTest::GetApMacHelper() const
+{
+    WifiMacHelper macHelper;
+    auto ssid = Ssid(WifiStaticEmlsrTestConstants::DEFAULT_SSID);
+
+    macHelper.SetType("ns3::ApWifiMac",
+                      "Ssid",
+                      SsidValue(ssid),
+                      "BeaconGeneration",
+                      BooleanValue(WifiStaticEmlsrTestConstants::DEFAULT_BEACON_GEN));
+    return macHelper;
+}
+
+WifiMacHelper
+WifiStaticEmlsrTest::GetClientMacHelper() const
+{
+    WifiMacHelper macHelper;
+    Ssid ssid = Ssid(WifiStaticEmlsrTestConstants::DEFAULT_SSID);
+    macHelper.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
+    macHelper.SetEmlsrManager("ns3::DefaultEmlsrManager",
+                              "EmlsrLinkSet",
+                              AttributeContainerValue<UintegerValue>(m_testVec.emlsrLinks),
+                              "AuxPhyChannelWidth",
+                              UintegerValue(m_testVec.auxPhyWidth),
+                              "SwitchAuxPhy",
+                              BooleanValue(m_testVec.switchAuxPhy));
+    return macHelper;
+}
+
+Ptr<WifiNetDevice>
+WifiStaticEmlsrTest::GetWifiNetDevice(bool isAp,
+                                      const WifiStaticEmlsrTestConstants::ChannelMap& channelMap)
+{
+    NodeContainer node(1);
+    auto wifiHelper = GetWifiHelper();
+    auto settings = isAp ? WifiStaticEmlsrTestConstants::DEFAULT_AP_CHS : m_testVec.clientChs;
+    auto phyHelper = GetPhyHelper(settings, channelMap);
+    auto macHelper = isAp ? GetApMacHelper() : GetClientMacHelper();
+    auto netDev = wifiHelper.Install(phyHelper, macHelper, node);
+    WifiHelper::AssignStreams(netDev, WifiStaticEmlsrTestConstants::DEFAULT_STREAM_INDEX);
+    return DynamicCast<WifiNetDevice>(netDev.Get(0));
+}
+
+void
+WifiStaticEmlsrTest::DoSetup()
+{
+    RngSeedManager::SetSeed(WifiStaticEmlsrTestConstants::DEFAULT_RNG_SEED);
+    RngSeedManager::SetRun(WifiStaticEmlsrTestConstants::DEFAULT_RNG_RUN);
+
+    WifiStaticEmlsrTestConstants::ChannelMap channelMap = {
+        {WIFI_PHY_BAND_2_4GHZ, CreateObject<MultiModelSpectrumChannel>()},
+        {WIFI_PHY_BAND_5GHZ, CreateObject<MultiModelSpectrumChannel>()},
+        {WIFI_PHY_BAND_6GHZ, CreateObject<MultiModelSpectrumChannel>()}};
+
+    m_apDev = GetWifiNetDevice(true, channelMap);
+    NS_ASSERT(m_apDev);
+    m_clientDev = GetWifiNetDevice(false, channelMap);
+    NS_ASSERT(m_clientDev);
+
+    WifiStaticSetupHelper::SetStaticAssociation(m_apDev, m_clientDev);
+    WifiStaticSetupHelper::SetStaticEmlsr(m_apDev, m_clientDev);
+}
+
+void
+WifiStaticEmlsrTest::ValidateEmlsr()
+{
+    auto clientMac = DynamicCast<StaWifiMac>(m_clientDev->GetMac());
+    NS_ASSERT_MSG(clientMac, "Expected StaWifiMac");
+    NS_TEST_ASSERT_MSG_EQ(clientMac->IsAssociated(), true, "Expected non-AP MLD to be associated");
+    auto setupLinks = clientMac->GetSetupLinkIds();
+    auto isMldAssoc = (setupLinks.size() > 1);
+    NS_TEST_ASSERT_MSG_EQ(isMldAssoc, true, "EMLSR mode requires association on multiple links");
+    auto emlsrManager = clientMac->GetEmlsrManager();
+    NS_ASSERT_MSG(emlsrManager, "EMLSR Manager not set");
+    auto clientEmlsrLinks = emlsrManager->GetEmlsrLinks();
+    auto match = (clientEmlsrLinks == m_testVec.emlsrLinks);
+    NS_TEST_ASSERT_MSG_EQ(match, true, "Unexpected set of EMLSR links enabled");
+    for (auto linkId : setupLinks)
+    {
+        auto expectedState = clientEmlsrLinks.contains(linkId);
+        auto clientLinkAddr = clientMac->GetFrameExchangeManager(linkId)->GetAddress();
+        auto apManager = m_apDev->GetRemoteStationManager(linkId);
+        auto actualState = apManager->GetEmlsrEnabled(clientLinkAddr);
+        NS_TEST_ASSERT_MSG_EQ(actualState,
+                              expectedState,
+                              "EMLSR state mismatch on client link ID " << +linkId);
+
+        // Validate Channel switch delay
+        auto actualDelay = clientMac->GetWifiPhy(linkId)->GetChannelSwitchDelay();
+        NS_TEST_ASSERT_MSG_EQ(actualDelay,
+                              m_testVec.switchDelay,
+                              "Channel switch delay mismatch on client link ID " << +linkId);
+    }
+}
+
+void
+WifiStaticEmlsrTest::DoRun()
+{
+    Simulator::Stop(WifiStaticEmlsrTestConstants::DEFAULT_SIM_STOP_TIME);
+    Simulator::Run();
+    ValidateEmlsr();
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief EMLSR static setup test suite
+ */
+class WifiStaticEmlsrTestSuite : public TestSuite
+{
+  public:
+    WifiStaticEmlsrTestSuite();
+};
+
+WifiStaticEmlsrTestSuite::WifiStaticEmlsrTestSuite()
+    : TestSuite("wifi-static-emlsr-test", Type::UNIT)
+{
+    auto CHANNELS_2_LINKS = {WifiStaticEmlsrTestConstants::CHANNEL_0,
+                             WifiStaticEmlsrTestConstants::CHANNEL_1};
+    auto CHANNELS_3_LINKS = {WifiStaticEmlsrTestConstants::CHANNEL_0,
+                             WifiStaticEmlsrTestConstants::CHANNEL_1,
+                             WifiStaticEmlsrTestConstants::CHANNEL_2};
+    auto CHANNELS_2_LINKS_ALT = {WifiStaticEmlsrTestConstants::CHANNEL_0,
+                                 WifiStaticEmlsrTestConstants::CHANNEL_2};
+
+    for (const std::vector<WifiStaticEmlsrTestVector> inputs{
+             {"Setup-2-link-EMLSR-2-link",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"Setup-3-link-EMLSR-2-link",
+              CHANNELS_3_LINKS,
+              {0, 1},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"Setup-3-link-EMLSR-2-link-Diff",
+              CHANNELS_3_LINKS,
+              {1, 2},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"Setup-3-link-EMLSR-2-link-Diff-2",
+              CHANNELS_3_LINKS,
+              {0, 2},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"Setup-3-link-EMLSR-3-link",
+              CHANNELS_3_LINKS,
+              {0, 1, 2},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"Setup-2-link-EMLSR-2-link-Diff-Set",
+              CHANNELS_2_LINKS_ALT,
+              {0, 2},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"EMLSR-2-link-16us-delay",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              MicroSeconds(16),
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"EMLSR-2-link-32us-delay",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              MicroSeconds(32),
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"EMLSR-2-link-80MHz-AuxPhy",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              MicroSeconds(32),
+              MHz_u{80},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_AUX_PHY},
+             {"EMLSR-2-link-Switch-Aux-PHY",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              WifiStaticEmlsrTestConstants::DEFAULT_AUX_PHY_CH_WIDTH,
+              true},
+             {"EMLSR-2-link-80MHz-AuxPhy-Switch",
+              CHANNELS_2_LINKS,
+              {0, 1},
+              WifiStaticEmlsrTestConstants::DEFAULT_SWITCH_DELAY,
+              MHz_u{80},
+              true}};
+         const auto& input : inputs)
+    {
+        AddTestCase(new WifiStaticEmlsrTest(input), TestCase::Duration::QUICK);
+    }
+}
+
+static WifiStaticEmlsrTestSuite g_wifiStaticEmlsrTestSuite;
